package cz.rny.piskvorky;

import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {
	private boolean hraje_krizek = true;
	private char[] herni_plocha = new char[9];
	private String jmeno_krizku = "KRIZEK", jmeno_kolecka = "KOLECKO";
	
	protected void ukaz_kdo_hraje() {
		TextView text = (TextView) findViewById(R.id.kdo_hraje);
		text.setText(hraje_krizek ? "Hraje krizek." : "Hraje kolecko.");
	}
    
	ImageView[] tlacitka = new ImageView[9];
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        
        ukaz_kdo_hraje();
        
        tlacitka[0] = (ImageView) findViewById(R.id.button1);
        tlacitka[1] = (ImageView) findViewById(R.id.button2);
        tlacitka[2] = (ImageView) findViewById(R.id.button3);
        tlacitka[3] = (ImageView) findViewById(R.id.button4);
        tlacitka[4] = (ImageView) findViewById(R.id.button5);
        tlacitka[5] = (ImageView) findViewById(R.id.button6);
        tlacitka[6] = (ImageView) findViewById(R.id.button7);
        tlacitka[7] = (ImageView) findViewById(R.id.button8);
        tlacitka[8] = (ImageView) findViewById(R.id.button9);

        final EditText krizek = (EditText) findViewById(R.id.jmeno_krizka);
        krizek.addTextChangedListener(new TextWatcher() {

			@Override
			public void afterTextChanged(Editable arg0) {
				jmeno_krizku = krizek.getText().toString();
			}

			@Override
			public void beforeTextChanged(CharSequence arg0, int arg1,
					int arg2, int arg3) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void onTextChanged(CharSequence s, int start, int before,
					int count) {
				// TODO Auto-generated method stub
				
			}
        	
        });
        final EditText kolecko = (EditText) findViewById(R.id.jmeno_kolecko);
        kolecko.addTextChangedListener(new TextWatcher() {

			@Override
			public void afterTextChanged(Editable arg0) {
				jmeno_kolecka = kolecko.getText().toString();
			}

			@Override
			public void beforeTextChanged(CharSequence arg0, int arg1,
					int arg2, int arg3) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void onTextChanged(CharSequence s, int start, int before,
					int count) {
				// TODO Auto-generated method stub
				
			}
        	
        });
        Button r = (Button) findViewById(R.id.reset);
        r.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				reset();
			}
        	
        });
        
        reset();
    }
    
    protected void reset() {
        for (int i = 0; i < 9; i++) {
        	herni_plocha[i] = ' ';
        }
        
        for (int i = 0; i < 9; i++) {
        	final int j = i;
        	final ImageView tlacitko = tlacitka[i];
        	tlacitko.setImageResource(R.drawable.prazdno);
        	tlacitko.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View arg0) {
					zmacknuto(j);
				}
        	});
        }
    }
    
    protected void vyhral(char symbol) {
    	Toast.makeText(MainActivity.this, "Vyhral: " + symbol, Toast.LENGTH_LONG).show();
    	reset();
    	
    	Intent i = new Intent(this, WinActivity.class);
    	i.putExtra("vyhral", symbol);
    	i.putExtra("jmeno", symbol == 'X' ? jmeno_krizku : jmeno_kolecka);
    	startActivity(i);
    }
    
    protected void zkontroluj_vyhru() {
    	for (int i = 0; i < 3; i++) {
    		char symbol = herni_plocha[3 * i];
    		boolean ok = true;
    		if (symbol == ' ') continue;
    		for (int j = 1; j < 3; j++) {
    			if (herni_plocha[3 * i + j] != symbol) {
    				ok = false;
    				break;
    			}
    		}
    		if (ok) {
    			vyhral(symbol);
    			return;
    		}
    	}
    	
    	for (int i = 0; i < 3; i++) {
    		char symbol = herni_plocha[i];
    		boolean ok = true;
    		if (symbol == ' ') continue;
    		for (int j = 1; j < 3; j++) {
    			if (herni_plocha[i + 3 * j] != symbol) {
    				ok = false;
    				break;
    			}
    		}
    		if (ok) {
    			vyhral(symbol);
    			return;
    		}
    	}	
    	
    	// TODO: diagonaly
    }
    
    protected void zmacknuto(int j) {
    	final ImageView tlacitko = tlacitka[j];
		if (herni_plocha[j] != ' ') {
			Toast.makeText(MainActivity.this, "Nehraj kde uz nekdo hral!", Toast.LENGTH_SHORT).show();
			return;
		}
		if (hraje_krizek) {
			tlacitko.setImageResource(R.drawable.krizek);
			herni_plocha[j] = 'X';
		} else {
			tlacitko.setImageResource(R.drawable.kolecko);
			herni_plocha[j] = 'O';
		}
		hraje_krizek = !hraje_krizek;
        ukaz_kdo_hraje();
        zkontroluj_vyhru();
    }
}
